#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "lukud.sis";
const char *OUT = "lukud.val";
const char *HINT = "lukud.xxx";

void ERR(const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("400\nError: ");
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

void OK(int n, const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    printf("200\nScore: %d\nError: ", n);
    vprintf(s, ap);
    printf("\n");
    va_end(ap);
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
    return s;
}

int n, m;
char a[100][100+10];
int k = 0;
int si = -1, sj = -1;
int fi = -1, fj = -1;
int k1, k2;
char s[20000+10];

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili avamisel");
    if (fscanf(in, "%d %d ", &n, &m) != 2)
        ERR("Viga sisendfaili lugemisel");
    for (int i = 0; i < n; ++i) {
        if (!fgets(a[i], sizeof(a[i]), in) || strlen(trim(a[i])) != m)
            ERR("Viga sisendfaili real %d", i + 2);
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == 'S') {
                if (si >= 0 || sj >= 0)
                    ERR("Vigane sisend: korduv lhtekoht");
                si = i; sj = j; a[si][sj] = '0';
            }
            if (a[i][j] == 'F') {
                if (fi >= 0 || fj >= 0)
                    ERR("Vigane sisend: korduv vljaps");
                fi = i; fj = j; a[fi][fj] = '0';
            }
            if (a[i][j] == 'K')
                ++k;
        }
    }
    if (fclose(in))
        ERR("Viga sisendfaili sulgemisel");

    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    if (!fgets(s, sizeof(s), hint))
        ERR("Viga vihjefaili lugemisel");
    k1 = strlen(trim(s));
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);
    if (!fgets(s, sizeof(s), out))
        OK(0, "Enneaegne faili lpp");
    k2 = strlen(trim(s));
    for (int i = 0; i < k2; ++i) {
        if (s[i] == 'N') --si;
        if (s[i] == 'S') ++si;
        if (s[i] == 'E') ++sj;
        if (s[i] == 'W') --sj;
        if (si < 0 || si >= n || sj < 0 || sj >= m)
            OK(0, "Katse vljuda kaardilt sammul %d", i + 1);
        if (a[si][sj] == 'K') {
            --k; a[si][sj] = '0';
        }
        if (a[si][sj] != '0')
            OK(0, "Katse minna lbi seina sammul %d", i + 1);
    }
    if (si != fi || sj != fj)
        OK(0, "Tee ei lpe vljapsu juures");
    if (k != 0)
        OK(0, "Vljumisel puudu %d vtit", k);
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed smbolid faili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    if (k2 != k1)
        OK(0, "Ebaoptimaalne lahend, %d sammu %d asemel", k2, k1);
    OK(100, "OK");
}
