#include <iostream>
using namespace std;

#define out(r, c) ((r) < 0 || (r) >= rr || (c) < 0 || (c) >= cc)
#define pass(r, c) (!out((r), (c)) && map[(r) * cc + (c)] == '0')
#define wall(r, c) (!out((r), (c)) && map[(r) * cc + (c)] == '1')
#define count(r, c) (pass((r) - 1, (c)) + pass((r) + 1, (c)) + pass((r), (c) - 1) + pass((r), (c) + 1))
#define avail(r, c) (wall((r), (c)) && count((r), (c)) == 1)

int main() {
    int rr, cc, kk;
    cin >> rr >> cc >> kk;

    char *map = new char[rr * cc];
    for (int r = 0; r < rr; ++r)
        for (int c = 0; c < cc; ++c)
            map[r * cc + c] = '1';

    map[(rand() % rr) * cc + (rand() % cc)] = '0';

    while (1) {
        int x = 0;
        for (int r = 0; r < rr; ++r)
            for (int c = 0; c < cc; ++c)
                if (pass(r, c)) {
                    if (avail(r - 1, c)) ++x;
                    if (avail(r + 1, c)) ++x;
                    if (avail(r, c - 1)) ++x;
                    if (avail(r, c + 1)) ++x;
                }
        if (x == 0)
            break;
        x = rand() % x;
        for (int r = 0; r < rr; ++r)
            for (int c = 0; c < cc; ++c)
                if (pass(r, c)) {
                    if (avail(r - 1, c) && x-- == 0) map[(r - 1) * cc + c] = '0';
                    if (avail(r + 1, c) && x-- == 0) map[(r + 1) * cc + c] = '0';
                    if (avail(r, c - 1) && x-- == 0) map[r * cc + (c - 1)] = '0';
                    if (avail(r, c + 1) && x-- == 0) map[r * cc + (c + 1)] = '0';
                }
    }

    int xx = 0;
    for (int r = 0; r < rr; ++r)
        for (int c = 0; c < cc; ++c)
            if (pass(r, c)) ++xx;
    if (xx < kk + 2) {
        cerr << "FAILED: " << xx << " slots for start, finish, and " << kk << " keys" << endl;
        return 1;
    }

    do {
        int x = rand() % xx;
        for (int r = 0; r < rr; ++r)
            for (int c = 0; c < cc; ++c)
                if (pass(r, c) && x-- == 0)
                    map[r * cc + c] = (kk > 0 ? 'K' : kk > -1 ? 'F' : 'S');
        --xx;
    } while (--kk > -2);

    cout << rr << " " << cc << endl;
    for (int r = 0; r < rr; ++r) {
        for (int c = 0; c < cc; ++c)
            cout << map[r * cc + c];
        cout << endl;
    }

    return 0;
}
