{ 2006-04-30 programmeerimisvistlus                                        }
{ lesanne: ROTT                                                            }
{ Autor: Kristo Tammeoja                                                    }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
    SIS_FAIL = 'rott.sis';
    VAL_FAIL = 'rott.val';
    MAX_MN = 30; // maksimaalne labrindi kljepikkus

    // labrindi legend
    LAB_TYHI = '0';
    LAB_SEIN = 'X';

var
    sfail, vfail : text; // sisend- ja vljundfail

    // labrindi mtmed ja kirjeldus
    m, n : integer;
    labyrint : array[0..MAX_MN+1, 0..MAX_MN+1] of char;

    // iga lahtri juurest teede arv juustutkini
    teid : array[1..MAX_MN, 1..MAX_MN] of int64;

    // vastus
    nr : longint;              // sisendina saadud arv...
    vastus : string[2*MAX_MN]; // ...ja sellele vastav tee

    i, j : integer;

begin
    // ----- avame failid -----
    assign(sfail, SIS_FAIL); reset(sfail);
    assign(vfail, VAL_FAIL); rewrite(vfail);

    // ----- loeme labrindi andmed -----
    // mtmed
    readln(sfail, m, n);
    // servad
    for i := 0 to m+1 do begin
        labyrint[i, 0] := LAB_SEIN;
        labyrint[i, n+1] := LAB_SEIN;
    end;
    for j := 0 to n+1 do begin
        labyrint[0, j] := LAB_SEIN;
        labyrint[m+1, j] := LAB_SEIN;
    end;
    // labrint ise
    for i := 1 to m do begin
        for j := 1 to n do begin
            read(sfail, labyrint[i, j]);
            if (labyrint[i, j] <> LAB_TYHI) and (labyrint[i, j] <> LAB_SEIN) then begin
                writeln('viga labrindi kirjelduses lahtris (', i, ', ', j, ')');
                halt(1);
            end;
        end;
        readln(sfail);
    end;

    // ----- lesanne -----
    // loeme tee numbri
    readln(sfail, nr);
    vastus := '';

    // ----- leiame iga lahtri juurest teede arvu juustutkini -----
    // esmalt nullime koik loendurid
    for i := 1 to m do
        for j := 1 to n do
            teid[i, j] := 0;
    // juustutki juurest on ks tee olemas (paigal seista ;)
    teid[m, n] := 1;
    // teiste lahtrite jaoks saame tulemused, hakates teede arvu juustutki
    // poolt tulles lugema
    for i := m downto 1 do
        for j := n downto 1 do begin
            // seina jaoks ei arvuta
            if labyrint[i, j] = LAB_SEIN then continue;

            // kui on vimalik paremale liikuda
            if labyrint[i, j+1] = LAB_TYHI then
                teid[i, j] := teid[i, j] + teid[i, j+1];
            // kui on vimalik alla liikuda
            if labyrint[i+1, j] = LAB_TYHI then
                teid[i, j] := teid[i, j] + teid[i+1, j];
        end;

    // kontrollime, kas ldse on nii palju teid olemas
    if nr > teid[1,1] then begin
        writeln('teede arv on ', teid[1,1]);
        halt(1);
    end;

    // ----- lesande lahendamine -----
    // kigepealt lheme esimesele ruudule
    i := 1;
    j := 1;
    // kuni pole veel lppu judnud
    while not ((i=m) and (j=n)) do begin
        // paremale minevad teed on thestikus eespool
        // kui neid on piisavalt palju...
        if (teid[i, j+1] >= nr) and (labyrint[i, j+1] = LAB_TYHI)
        then begin
            // liigume paremale
            vastus := vastus + 'E';
            j := j+1;
        end else begin
            // liigume alla
            vastus := vastus + 'S';
            nr := nr - teid[i, j+1];
            i := i+1;
        end;
    end; // while

    // ----- vastus -----
    writeln(vfail, vastus);

    // ----- sulgeme failid -----
    close(sfail);
    close(vfail);
end.
